/*
 * Copyright (C) 2022  Aravinth Manivannan <realaravinth@batsense.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
use std::env;
use std::path::Path;

use config::{builder::DefaultState, Config, ConfigBuilder, ConfigError, Environment, File};
use derive_more::Display;
use log::info;
use log::warn;
use serde::Deserialize;
use serde::Serialize;
use url::Url;

const PREFIX: &str = "LPCONDUCTOR";
const SEPARATOR: &str = "_";

#[derive(Debug, Clone, Deserialize)]
pub struct Server {
    pub port: u32,
    pub domain: String,
    pub ip: String,
    pub url_prefix: Option<String>,
    pub proxy_has_tls: bool,
}

impl Server {
    #[cfg(not(tarpaulin_include))]
    pub fn get_ip(&self) -> String {
        format!("{}:{}", self.ip, self.port)
    }
}

#[derive(Deserialize, Serialize, Display, Eq, PartialEq, Clone, Debug)]
#[serde(rename_all = "lowercase")]
pub enum ConductorType {
    /// doesn't do anything
    #[display(fmt = "dummy")]
    Dummy,
}

#[derive(Debug, Clone, Deserialize)]
pub struct Creds {
    pub token: String,
}

#[derive(Debug, Clone, Deserialize)]
pub struct Settings {
    pub debug: bool,
    pub creds: Creds,
    pub server: Server,
    pub source_code: Url,
    pub conductor: ConductorType,
}

#[cfg(not(tarpaulin_include))]
impl Settings {
    pub fn authenticate(&self, token: &str) -> bool {
        self.creds.token == token
    }

    pub fn new() -> Result<Self, ConfigError> {
        let mut s = Config::builder();

        const CURRENT_DIR: &str = "./config/config.toml";
        const ETC: &str = "/etc/lpconductor/config.toml";

        if let Ok(path) = env::var("LPCONDUCTOR_CONFIG") {
            s = s.add_source(File::with_name(&path));
        } else if Path::new(CURRENT_DIR).exists() {
            // merging default config from file
            s = s.add_source(File::with_name(CURRENT_DIR));
        } else if Path::new(ETC).exists() {
            s = s.add_source(File::with_name(ETC));
        } else {
            warn!("configuration file not found");
        }

        s = s.add_source(Environment::with_prefix(PREFIX).separator(SEPARATOR));
        s = set_separator_field(s);

        match env::var("PORT") {
            Ok(val) => {
                s = s.set_override("server.port", val).unwrap();
            }
            Err(e) => warn!("couldn't interpret PORT: {}", e),
        }

        let s = s.build()?;
        match s.try_deserialize::<Self>() {
            Ok(val) => {
                Ok(val)
            },
            Err(e) => Err(ConfigError::Message(format!("\n\nError: {}. If it says missing fields, then please refer to https://git.batsense.net/LibrePages/conductor to learn more about how conductor reads configuration\n\n", e))),
        }
    }
}

#[cfg(not(tarpaulin_include))]
fn set_separator_field(mut s: ConfigBuilder<DefaultState>) -> ConfigBuilder<DefaultState> {
    // ref: https://github.com/mehcode/config-rs/issues/391

    fn from_env(
        s: ConfigBuilder<DefaultState>,
        env_name: &str,
        config_name: &str,
    ) -> ConfigBuilder<DefaultState> {
        if let Ok(val) = env::var(env_name) {
            info!("Overriding {config_name} with data from env var {env_name}");
            s.set_override(config_name, val)
                .unwrap_or_else(|_| panic!("Couldn't set {config_name}  from env var {env_name}"))
        } else {
            s
        }
    }
    s = from_env(s, &format!("{PREFIX}{SEPARATOR}SOURCE_CODE"), "source_code");
    s = from_env(
        s,
        &format!("{PREFIX}{SEPARATOR}SERVER{SEPARATOR}URL_PREFIX"),
        "server.url_prefix",
    );
    s = from_env(
        s,
        &format!("{PREFIX}{SEPARATOR}SERVER{SEPARATOR}PROXY_HAS_TLS"),
        "server.proxy_has_tls",
    );

    s = from_env(
        s,
        &format!("{PREFIX}{SEPARATOR}CREDS{SEPARATOR}TOKEN"),
        "creds.token",
    );

    s
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn creds_works() {
        let settings = Settings::new().unwrap();
        let creds = settings.creds.clone();

        assert!(settings.authenticate(&creds.token));

        let mut creds = settings.creds.clone();

        creds.token = "noexist".into();
        assert!(!settings.authenticate(&creds.token))
    }
}
